hdu 5534 Partial Tree(完全背包)

来源:互联网 发布:区和县的区别 知乎 编辑:程序博客网 时间:2024/05/29 19:45

Partial Tree

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)
Total Submission(s): 1451    Accepted Submission(s): 724


Problem Description
In mathematics, and more specifically in graph theory, a tree is an undirected graph in which any two nodes are connected by exactly one path. In other words, any connected graph without simple cycles is a tree.

You find a partial tree on the way home. This tree has n nodes but lacks of n1 edges. You want to complete this tree by adding n1 edges. There must be exactly one path between any two nodes after adding. As you know, there are nn2 ways to complete this tree, and you want to make the completed tree as cool as possible. The coolness of a tree is the sum of coolness of its nodes. The coolness of a node is f(d), where f is a predefined function and d is the degree of this node. What's the maximum coolness of the completed tree?
 

Input
The first line contains an integer T indicating the total number of test cases.
Each test case starts with an integer n in one line,
then one line with n1 integers f(1),f(2),,f(n1).

1T2015
2n2015
0f(i)10000
There are at most 10 test cases with n>100.
 

Output
For each test case, please output the maximum coolness of the completed tree in one line.
 

Sample Input
232 145 1 4
 

Sample Output
519


题意:给出n个点,要求你连n-1条边使得这个图成为一颗树,给出每个度数的权值,求总的权值和最大;

解:因为每个点一定要连一条边,所以先给每个点分配一度,总度数是2*(n-1),还剩n-2度,所以是个完全背包,之所以可以用背包是因为,一定可以将f[1...n-1]的度数

分配出去;


#include <iostream>#include <cstdio>#include <cstring>#include <cmath>#include <algorithm>#include <map>#include <queue>#include <bits/stdc++.h>using namespace std;typedef long long LL;const int N = 3e5+7;int f[N], dp[3000];int main(){    int t;    scanf("%d", &t);    while(t--)    {        int n;        scanf("%d", &n);        for(int i=1;i<n;i++) scanf("%d", &f[i]);        int ans=(n*f[1]);        for(int i=2;i<n;i++) f[i]-=f[1];        for(int i=1;i<n-1;i++) f[i]=f[i+1];        memset(dp,-0x3f3f3f3f,sizeof(dp));        dp[0]=0;        for(int i=1;i<=n-2;i++)        {            for(int j=i;j<=n-2;j++)            {                dp[j]=max(dp[j],dp[j-i]+f[i]);            }        }        printf("%d\n",dp[n-2]+ans);    }    return 0;}






原创粉丝点击